#ifndef _OPENDRIVE_ARC_H
#define _OPENDRIVE_ARC_H

#include "opendrive_geometry.h"

class COpendriveArc : public COpendriveGeometry
{
  friend class COpendriveRoadNode;
  private:
    double curvature;
  protected:
    COpendriveArc();
    COpendriveArc(const COpendriveArc &object);
    virtual bool transform_local_pose(TOpendriveTrackPoint &track,TOpendriveLocalPoint &local) const;
    virtual void print(std::ostream &out);
    virtual void load_params(const planView::geometry_type &geometry_info);
    virtual std::string get_name(void);
  public:
    virtual COpendriveGeometry *clone(void);
    virtual void get_curvature(double &start,double &end);
    void operator=(const COpendriveArc &object);
    ~COpendriveArc();
};

#endif
