#ifndef _OPENDRIVE_SPIRAL_H
#define _OPENDRIVE_SPIRAL_H

#include "opendrive_geometry.h"

class COpendriveSpiral : public COpendriveGeometry
{
  friend class COpendriveRoadNode;
  private:
    double start_curvature;
    double end_curvature;
  protected:
    COpendriveSpiral();
    COpendriveSpiral(const COpendriveSpiral &object);
    virtual bool transform_local_pose(TOpendriveTrackPoint &track,TOpendriveLocalPoint &local) const;
    virtual void print(std::ostream &out);
    virtual void load_params(const planView::geometry_type &geometry_info);
    virtual std::string get_name(void);
  public:
    virtual COpendriveGeometry *clone(void);
    virtual void get_curvature(double &start,double &end);
    void operator=(const COpendriveSpiral &object);
    ~COpendriveSpiral();
};

#endif
