#include "opendrive_road.h"
#include "exceptions.h"
#include <iostream>
#include <vector>
#include <limits>

int main(int argc, char *argv[])
{
  TOpendriveWorldPoint closest_point;
  double length,x,y,heading;
//  std::vector<double> x,y;
  COpendriveRoad road;
//  std::string xml_file="/home/sergi/iri-lab/adc_ws/code/autonomous_driving_tools/src/xml/add_road_full.xodr";
  std::string xml_file="/home/sergi/iri-lab/adc_ws/code/autonomous_driving_tools/src/xml/adc_road.xodr";
  
  try
  {
    road.set_resolution(0.01);
    road.set_scale_factor(10.0);
    road.set_min_road_length(0.01);
    road.load(xml_file);
//    std::cout << road << std::endl;
/*
    for(unsigned int i=0;i<road.get_num_nodes();i++)
    {
      const COpendriveRoadNode &node=road.get_node(i);
      for(unsigned int j=0;j<node.get_num_links();j++)
      {
        const COpendriveLink &link=node.get_link(j);
        link.get_trajectory(x,y);
        for(unsigned int k=0;k<x.size();k++)
          std::cout << x[k] << "," << y[k] << std::endl;
      }
    }
*/
    if(argc!=4)
    {
      std::cout << "Invalid number of parameters" << std::endl;
      std::cout << argv[0] << " x y heading" << std::endl;
      return -1;
    }
    x=std::stod(argv[1]);
    y=std::stod(argv[2]);
    heading=std::stod(argv[3]);
    length=road.get_closest_point(x,y,heading,closest_point);
    std::cout << "closest point to: " << x << "," << y << "," << heading << " -> " << closest_point.x << "," << closest_point.y << "," << closest_point.heading << " at " << length << " m" << std::endl;
    
  }
  catch (CException &e)
  {
    std::cout << "[Exception caught] : " << e.what() << std::endl;
  }
  return 0;
}
